<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>Snake</title>
    <style>
        body {
            background-color: rgb(186, 199, 181);
        }

        #myCanvas {
            background-color: seagreen;
            display: block;
            margin: auto;

        }

        h1 {
            text-align: center;
            font-family: Arial, Helvetica, sans-serif;
            color: seagreen;
            text-shadow: 2px 2px 1px black;
        }

        #score {
            text-align: center;
            font-family: Arial, Helvetica, sans-serif;
            color: seagreen;
            text-shadow: 1px 1px 1px black;
            font-size: x-large;
        }
    </style>
</head>

<body>

    <h1>Snake</h1>
    <canvas id="myCanvas" width="400" height="400" style="border:2px solid;"> Nettleseren din støtter ikke
        HTML5</canvas>
    <div id="score">Score: 0</div>

    <script>
        //draw in canvas
        var c = document.getElementById("myCanvas");
        var ctx = c.getContext("2d");

        var rows = 15;
        var columns = 15;

        var xPos;
        var yPos;

        var size;
        var arrowKey;
        var dir;

        var map;

        var rRow;
        var rCol;

        resetMap();

        var varTimer = setInterval(myTimer, 100);

        function myTimer() {
            ctx.clearRect(0, 0, c.width, c.height);

            while (arrowKey.length > 0 &&
                ((arrowKey[0] == 1 && map[yPos][xPos - 1] > 0)
                    || (arrowKey[0] == 2 && map[(yPos + columns - 1) % columns][xPos] > 0)
                    || (arrowKey[0] == 3 && map[yPos][xPos + 1] > 0)
                    || (arrowKey[0] == 4 && map[(yPos + rows + 1) % rows][xPos] > 0))) {
                arrowKey.shift()
            }
            if (arrowKey.length > 0) dir = arrowKey.shift();

            if (dir == 1) xPos--;
            else if (dir == 2) yPos--;
            else if (dir == 3) xPos++;
            else if (dir == 4) yPos++;

            xPos = (xPos + columns) % columns;
            yPos = (yPos + rows) % rows;

            if (map[yPos][xPos] == -1) {
                size++;
                do {
                    rRow = Math.floor(Math.random() * rows);
                    rCol = Math.floor(Math.random() * columns);
                } while (map[rRow][rCol] != 0)
                map[rRow][rCol] = -1;
            }

            if (map[yPos][xPos] > 0) {
                resetMap();
            }

            map[yPos][xPos] = 1;

            drawMap(map);
            if (size > 3) document.getElementById("score").innerHTML = "Score: " + (size - 3);
        }

        window.onkeydown = function (e) { //test for keypress
            key = e.keyCode ? e.keyCode : e.which; //stores keynumber in var key

            if (key - 36 > 0 && key - 36 <= 4 && arrowKey.length < 2) {
                arrowKey.push(key - 36);
            }
        }


        function drawMap(array) {
            for (var i = 0; i < columns; i++) {
                for (var j = 0; j < rows; j++) {
                    if (array[i][j] > 0) {
                        drawBox(j, i);
                        if (array[i][j]++ == size) array[i][j] = 0;
                    } else if (array[i][j] == -1) {
                        ctx.fillStyle = "red";
                        drawBox(j, i);
                        ctx.fillStyle = "black";
                    }
                }
            }
        }

        function drawBox(x, y) {
            width = c.width / columns
            height = c.height / rows

            x *= width;
            y *= height;

            ctx.beginPath();
            ctx.moveTo(x, y);
            ctx.lineTo(x + width, y);
            ctx.lineTo(x + width, y + height);
            ctx.lineTo(x, y + height);
            ctx.lineTo(x, y);

            ctx.fill();
        }

        function resetMap() {
            xPos = 5;
            yPos = 5;

            size = 3;
            arrowKey = [];
            dir = 2;

            map = Array(rows).fill().map(() => Array(columns).fill(0));

            for (var i = 0; i < 2; i++) {
                do {
                    rRow = Math.floor(Math.random() * rows);
                    rCol = Math.floor(Math.random() * columns);
                } while (map[rRow][rCol] != 0)
                map[rRow][rCol] = -1;
            }
        }
    </script>

</body>

</html>